<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object
	private $obj_branch;
	private $obj_course;
	private $obj_paging;
	private $obj_date;
	
	// variabel
	private $str_keyword;
	private $str_stat_admin;
	private $str_tgl;
	private $int_bln1 = '';
	private $int_bln2 = '';
	private $int_thn = '';
	private $int_city;
	private $list_city;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load object business "data"
		$this->obj_branch = $this->obj_ctrl->LoadBusiness('cabang', 'mysql', $this->arr_config['db']);
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);	
		$this->obj_coursesqli = $this->obj_ctrl->LoadBusiness('course', 'mysqli', $this->arr_config['db']);
		// load object pagination
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		
		// library loaded
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');		
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded
		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded body event
		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");
		
	}
	
	public function PageView(){
		// display variabel
		self::DisplayVariabel();
		// display list
		self::DisplayRedirect();
		// display var search
		//self::DisplaySearch();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	private function DisplayVariabel(){
		$this->obj_tmpl->addVar('content', 'URL_KOLEKTIF', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list-peserta'));
		$this->obj_tmpl->addVar('content', 'URL_INDIVIDU', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list-peserta',array('peserta')));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list'));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// parameter pencarian
		
		
	}
	
	private function DisplayRedirect() {
		if (isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "list") {
			self::DisplayListDataCourse();
		}elseif(isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "peserta") {
			self::DisplayPesertaBaru();
		}elseif(isset($this->arr_routes['params']['0']) && $this->arr_routes['params']['0'] == "view-wilayah") {
		
		}else{
			self::DisplayListData();
		}
   }
	
	// display penyelengara peserta kolektif
	private function DisplayListData(){
			// url proses cari
		$this->obj_tmpl->addVar('display', 'URL_PROCESS_CARI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));

	
		$this->obj_tmpl->addVar('content', 'KOLEKTIF', 'style="font-weight: bold;"');
		if(!isset($this->arr_routes['params']['0'])) {
			$page = 1;
		}else{
			$page = $this->arr_routes['params']['0'];
		}
		// set key search nama penyenyelenggara
		$key_search = (isset($_SESSION['key_search'])?'%'.$_SESSION['key_search'].'%':'%');
		$this->obj_tmpl->addVar('display', 'KEYSEARCH', (isset($_SESSION['key_search'])?$_SESSION['key_search']:''));
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(20);
		// set total record
		//$this->obj_branch->DebugQuery('GetCountPenyelenggaraPesertaKolektif',array($key_search));
		$total = $this->obj_branch->GetDataAsSingleArray('GetCountPenyelenggaraPesertaKolektif',array($key_search));

		$this->obj_paging->SetTotalRecord($total['TOTAL']);
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// set template
		$this->obj_paging->SetTempatePaging('pagination');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		
		$cabang = $this->obj_branch->GetDataAsArray('GetPenyelenggaraPesertaKolektif',array($key_search,$start, $max));
			
		if (sizeof($cabang) > 0) {
			$this->obj_tmpl->addVar('cat', 'cat', 'have');
		}
		$no = 0;
		$num = $start + 1;
		foreach($cabang as $key => $value) {
			$href = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array("view-wilayah", $value['id_penyelenggara']));
			$href1 = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($value['id_penyelenggara'],$page));
			$url_list = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list-peserta', array('list',$value['id_penyelenggara'],$page));
			$url_verify = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array("verify", $value['id_penyelenggara']));
			// --
			if($value['status'] == "NOT VERIFIED"){
				$img = "red";
			}else{
				$img = "green";
			}
			
			$this->obj_tmpl->addVar('list_data', 'URL_VERIFY', $url_verify);
			$this->obj_tmpl->addVar('list_data', 'IMG_VERIFICATION', $img);
			$this->obj_tmpl->addVar('list_data', 'INDEX', $no);
			$this->obj_tmpl->addVar('list_data', 'NO', $num);
			$this->obj_tmpl->addVar('list_data', 'ID', $value['id_penyelenggara']);	
			$this->obj_tmpl->addVar('list_data', 'NAME', $value['nama']);
			$this->obj_tmpl->addVar('list_data', 'ADDRESS', $value['alamat']);
			$this->obj_tmpl->addVar('list_data', 'TELEPHONE', $value['telephone']);
			$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $href1);
			$this->obj_tmpl->addVar('list_data', 'URL_WILAYAH', $href);
			$this->obj_tmpl->addVar('list_data', 'URL_LIST', $url_list);	
			$this->obj_tmpl->ParseTemplate('list_data', 'a');
			$no++;
			$num++;
		}
	}
	
	// display list data course penyelenggara kolektif
	private function DisplayListDataCourse(){
		// set parameter pages on index [0]
		$this->obj_tmpl->addVar('content', 'KOLEKTIF', 'style="font-weight: bold;"');
		$this->obj_tmpl->addVar('display', 'view', 'view-course');
		if(!isset($this->arr_routes['params'][2]))
			$page = 1;
		else
			$page = $this->arr_routes['params'][2];
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(10);
		// set total record
		//echo $this->str_keyword, $this->str_stat;
		$result = $this->obj_coursesqli->GetDataAsSingleArray("GetTotalCourseByIdPenyelenggara", array($this->arr_routes['params'][1]));
		//print_r(array($this->str_stat_admin, $this->int_bln1, $this->int_bln2, $this->int_thn));
		$this->obj_paging->SetTotalRecord($result['TOTAL']);
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'],array('list',$this->arr_routes['params'][1],'/')));
		// set template
		$this->obj_paging->SetTempatePaging('pagination_view-course');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		// parsing data
		$rs_id = $this->obj_coursesqli->GetResourceId("GetListCourseByIdPenyelenggara", array($this->arr_routes['params'][1], $start, $max));	
		
		if($rs_id){
			$no = $start + 1;
			while($rec = $rs_id->fetch_assoc()){
				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($page, $rec['id_course']));
				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'hapus', array($page, $rec['id_course']));
				$url_peserta = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'peserta-kolektif', array('list',$this->arr_routes['params'][1],$page, $rec['id_course']));
				$this->obj_tmpl->addVar('list_data_course', 'URL_DISPLAY', $url_peserta);
				$this->obj_tmpl->addVar('list_data_course', 'URL_HAPUS', $url_hapus);
				//$this->obj_tmpl->addVar('list_data_course', 'URL_PESERTA', $url_peserta);
				$this->obj_tmpl->addVar('list_data_course', 'NO', $no);
				$this->obj_tmpl->addVar('list_data_course', 'ID', $rec['id_course']);
				$tgl = explode(" ", self::GetTanggalCourseById($rec['id_course']));
				$tgl = $this->obj_date->GetFullDate($tgl[1])."-".$this->obj_date->GetFullDate($tgl[2]);
				$this->obj_tmpl->addVar('list_data_course', 'TANGGAL', $tgl);
				if($rec['status_verifikasi']=='waiting')
					$this->obj_tmpl->addVar('list_data_course', 'STATUS', 'Waiting');
				else if($rec['status_verifikasi']=='reject')
					$this->obj_tmpl->addVar('list_data_course', 'STATUS', 'Reject');
				else
					$this->obj_tmpl->addVar('list_data_course', 'STATUS', 'Verified');
				
				$this->obj_tmpl->addVar('list_data_course', 'TEMPAT', $rec['tempat']);
				$this->obj_tmpl->addVar('list_data_course', 'ALAMAT', $rec['alamat']);
				$this->obj_tmpl->addVar('list_data_course', 'KAPASITAS', $rec['kapasitas']);
				$this->obj_tmpl->addVar('list_data_course', 'SISA', $rec['sisa']);
				$result = $this->obj_branch->GetDataAsSingleArray("GetCabangById", array($rec['id_penyelenggara']));
				if(!empty($result))
					$this->obj_tmpl->addVar('list_data_course', 'PENYELENGGARA', $result['nama']);
				else
					$this->obj_tmpl->addVar('list_data_course', 'PENYELENGGARA', 'None');
				$this->obj_tmpl->addVar('list_data_course', 'KOTA', $rec['city_name']);
				$this->obj_tmpl->addVar('list_data_course', 'PJ', $rec['penanggung_jawab']);
				$this->obj_tmpl->addVar('list_data_course', 'TEKNISI', $rec['teknisi']);
				$this->obj_tmpl->addVar('list_data_course', 'PERAWAT', $rec['perawat']);
				$this->obj_tmpl->addVar('list_data_course', 'TGL_AKHIR', $this->obj_date->GetFullDate($rec['tgl_akhir_daftar']));
				$this->obj_tmpl->ParseTemplate('list_data_course', 'a');
				$no++;
			}
		}
	}
	
	//	display peserta baru
	private function DisplayPesertaBaru(){
		// set parameter pages on index [0]
		$this->obj_tmpl->addVar('content', 'INDIVIDU', 'style="font-weight: bold;"');
		$this->obj_tmpl->addVar('display', 'view', 'view-peserta');
		if(!isset($this->arr_routes['params'][1]))
			$page = 1;
		else
			$page = $this->arr_routes['params'][1];
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(10);
		// set total record
		//echo $this->str_keyword, $this->str_stat;
		$result = $this->obj_coursesqli->GetDataAsSingleArray("GetCountPesertaBaru", array());
		//print_r(array($this->str_stat_admin, $this->int_bln1, $this->int_bln2, $this->int_thn));
		$this->obj_paging->SetTotalRecord($result['TOTAL']);
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'],array('peserta','/')));
		// set template
		$this->obj_paging->SetTempatePaging('pagination_view-peserta');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		$rs_id = $this->obj_course->GetResourceId("GetListPesertaBaru", array($start,$max));
		
		if($rs_id){
			$no = $start+1;
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_data_peserta', 'NO', $no);
				$this->obj_tmpl->addVar('list_data_peserta', 'PREFIX', $rs['prefix']);
				$this->obj_tmpl->addVar('list_data_peserta', 'NAMA', $rs['nama']);
				$this->obj_tmpl->addVar('list_data_peserta', 'SUFFIX', $rs['suffix']);
				$this->obj_tmpl->addVar('list_data_peserta', 'TGL_DAFTAR', $this->obj_date->GetFullDate($rs['tgl_daftar']));
				$this->obj_tmpl->addVar('list_data_peserta', 'ALAMAT', $rs['alamat']);
				$this->obj_tmpl->addVar('list_data_peserta', 'KODE_BAYAR', $rs['kode_bayar']);
				$this->obj_tmpl->addVar('list_data_peserta', 'TLP', $rs['no_telp']);
				$this->obj_tmpl->addVar('list_data_peserta', 'HP', $rs['no_hp']);
				$no++;
				// link
				$url_detail = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pdetail2', array('peserta',$page, $rs['id_peserta'], $rs['id_course'], $rs['id_person']));
				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'phapus2', array('peserta',$page, $rs['id_peserta'], $rs['id_course']));
				$this->obj_tmpl->addVar('list_data_peserta', 'URL_DETAIL', $url_detail);
				$this->obj_tmpl->addVar('list_data_peserta', 'URL_DELETE', $url_hapus);
				// status
				if($rs['status'] == 'booking'){
					$this->obj_tmpl->addVar('list_data_peserta', 'STATUS', 'Belum membayar');
				} else if($rs['status'] == 'bayar'){
					$this->obj_tmpl->addVar('list_data_peserta', 'STATUS', 'Sudah membayar');
				} else {
					$this->obj_tmpl->addVar('list_data_peserta', 'STATUS', 'Batal');
				}
				$this->obj_tmpl->ParseTemplate('list_data_peserta', 'a');
			}
		}
	
	}
	
	private function GetTanggalCourseById($id_course){
		$this->str_tgl = "";
		$rs_id = $this->obj_course->GetResourceId("GetTanggalCourseById", array($id_course, $id_course));
		if($rs_id){
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->str_tgl = $this->str_tgl.' '.$rs['tanggal'];
			}
		}
		return $this->str_tgl;
	}
	
	
}

?>