<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	private $obj_course;
	private $obj_notify;
	private $obj_date;
	private $obj_registrasi;
	// init variabel
	private $str_tgl;
	private $str_desc;
	private $str_idjadwal;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// business object loaded
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		//display variabel
		self::DisplayVariabel();
		// display form
		self::DisplayForm();
		// display data edit
		self::DisplayEditData();
		// display test cookies
		self::DisplayNotification();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	// get city name
	private function GetNameCityById($idcity){
		$result = $this->obj_registrasi->GetDataAsSingleArray("GetCityById", array($idcity));
		return $result['city_name'];
	}
	// declare variable
	private function DisplayVariabel(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'add'));
		
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->arr_routes['params'][0])));
		
		$this->obj_tmpl->addVar('content', 'URL_EDIT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($this->arr_routes['params'][0], $this->arr_routes['params'][1])));
		
		$this->obj_tmpl->addVar('content', 'URL_MATERI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'materi', array($this->arr_routes['params'][0], $this->arr_routes['params'][1], $this->arr_routes['params'][2])));
		
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATAMATERI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'modul'));
		
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATAINSTRUKTUR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'instruktur'));
		
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATAJAM', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'jam'));
		
		$this->obj_tmpl->addVar('content', 'PAGE', $this->arr_routes['params'][0]);
	}
	// function display information
	private function DisplayForm(){
		$params = array($this->arr_routes['params'][1]);
		$result = $this->obj_course->GetDataAsSingleArray("GetDetailCourseById", $params);
		if(!empty($result)){
			$this->obj_tmpl->addVar('content', 'ID_COURSE', $result['id_course']);
			$this->obj_tmpl->addVar('content', 'TEMPAT_UTAMA', $result['tempat']);
			$this->obj_tmpl->addVar('content', 'PJ', $result['penanggung_jawab']);
			$this->obj_tmpl->addVar('content', 'TEKNISI', $result['teknisi']);
			$this->obj_tmpl->addVar('content', 'NURSE', $result['perawat']);
			$this->obj_tmpl->addVar('content', 'SESI', $result['nomor_pelatihan']);
			$this->obj_tmpl->addVar('content', 'KAPASITAS', $result['kapasitas']);
			$biaya = "Rp&ensp;".number_format(intval($result['harga'])).",-";
			$this->obj_tmpl->addVar('content', 'HARGA', $biaya);
			self::GetAllTanggalCourseById($this->arr_routes['params'][2]);
			$this->obj_tmpl->addVar('content', 'KOTA', self::GetNameCityById($result['id_city']));
		}
	}
	// ambil tanggal pelatihan
	private function GetAllTanggalCourseById($id_course_jadwal){
		$params = array($id_course_jadwal);
		$result = $this->obj_course->GetDataAsSingleArray("GetTanggalCourseByIdJadwal", $params);
		if(!empty($result)){
			$this->obj_tmpl->addVar('content', 'TGL', $this->obj_date->GetFullDate($result['tanggal']));
			$this->obj_tmpl->addVar('content', 'TEMPAT', $result['deskripsi_tempat']);
			$this->obj_tmpl->addVar('content', 'ID_JADWAL', $result['id_course_jadwal']);
		}	
	}
	// fungsi data edit
	private function DisplayEditData(){
		$result = $this->obj_course->GetDataAsSingleArray("GetListMateriById", array($this->arr_routes['params'][3]));	
		if($result){
			$this->obj_tmpl->addVar('content', 'ID_MATERI', $result['id_course_materi']);
			$this->obj_tmpl->addVar('content', 'START_TIME', $result['jam_mulai']);
			$this->obj_tmpl->addVar('content', 'END_TIME', $result['jam_selesai']);
			$this->obj_tmpl->addVar('content', 'MATERI', $result['materi']);
			$this->obj_tmpl->addVar('content', 'INSTRUKTUR', self::GetNamaInstruktur($result['id_instruktur']));
		}
	}
	
	private function GetNamaInstruktur($id_instruktur){
		$result = $this->obj_course->GetDataAsSingleArray("GetNamaInstruktur", array($id_instruktur));
		if(!empty($result)){
			return $result['nama_instruktur'];
		}	
	}
	
	// function show notify
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>
