<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	// init object
	private $obj_crypt;
	private $obj_notify;
	private $obj_course;
	private $obj_date;
	// deklarasi variabel session id_course
	private $str_idcourse;
	private $str_tgl;
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// call function to set page templates
		$this->SetPageTemplates();
		// --
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		// load javascript 
		$this->obj_ctrl->LoadJavascript('jquery-1.3.2', 'jquery.ui');
		$this->obj_ctrl->LoadJavascript('ui/ui.core', 'jquery.ui');
		$this->obj_ctrl->LoadJavascript('ui/ui.datepicker', 'jquery.ui');
		// load style
		$this->obj_ctrl->LoadStyle('base/ui.all', 'jquery.ui');
		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
		// load crypt function
		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		// load date function
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		
	}
	
	public function PageView(){
		// fungsi display variabel
		self::DisplayVariable();
		// fungsi get data 
		self::GetDataPeserta();
		// display test cookies
		self::DisplayNotification();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	// fungsi display variabel
	private function DisplayVariable(){
		$this->obj_tmpl->addVar('content', 'URL_LIST_PESERTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'peserta', array($this->arr_routes['params'][0],$this->arr_routes['params'][1])));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'PAGE', $this->arr_routes['params'][1]);
		//link image
		$this->obj_tmpl->addVar('content', 'JQUERY_STYLE', HTTPPATH.'doc/temp/');
	}
	// fungsi get data peserta
	private function GetDataPeserta(){
		$rs = $this->obj_course->GetDataAsSingleArray("GetPesertaByIdPeserta", array($this->arr_routes['params'][2]));
		if(!empty($rs)){
			//foto
			$file_photo = "doc/person/".$rs['id_person']."/foto/".$rs['photo'];
			if(is_file($file_photo))
				$this->obj_tmpl->addVar('content', 'PHOTO', HTTPPATH.$file_photo);
			else
				$this->obj_tmpl->addVar('content', 'PHOTO', HTTPPATH."doc/temp/blank.jpg");
			$this->obj_tmpl->addVar('content', 'NAMA_GELAR', $rs['NAMA_GELAR']);
			$this->obj_tmpl->addVar('content', 'TGL_BATAS', $rs['tgl_jatuh_tempo']);
			$this->obj_tmpl->addVar('content', 'ID_PESERTA', $rs['id_peserta']);
			$this->obj_tmpl->addVar('content', 'ID_COURSE', $rs['id_course']);
			$this->obj_tmpl->addVar('content', 'ID_PERSON', $rs['id_person']);
			$this->obj_tmpl->addVar('content', 'CODE_PAY', $rs['kode_bayar']);
			$this->obj_tmpl->addVar('content', 'PLACE', $rs['tempat']);
			$this->obj_tmpl->addVar('content', 'CITY', $rs['city_name']);
			$this->obj_tmpl->addVar('content', 'PROVINCE', $rs['province_name']);
			$this->obj_tmpl->addVar('content', 'KOOR', $rs['penanggung_jawab']);
			//$this->obj_tmpl->addVar('content', 'ID_PENYELENGGARA', $this->arr_routes['params'][4]);
			$tgl = explode(" ", self::GetTanggalCourseById($rs['id_course']));
			$tgl = $this->obj_date->GetFullDate($tgl[1])." - ".$this->obj_date->GetFullDate($tgl[2]);
			if($rs['status'] == 'booking'){
				$this->obj_tmpl->addVar('content', 'BOOKING', 'selected=selected');
			}else if($rs['status'] == 'bayar'){
				$this->obj_tmpl->addVar('content', 'BAYAR', 'selected=selected');
			}else{
				$this->obj_tmpl->addVar('content', 'BATAL', 'selected=selected');
			}
			
			if($rs['status'] != 'bayar'){
				$button = "<input type=\"submit\" value=\"Generate\" name=\"save[new_code]\" class=\"edit-button\" />";	
				$this->obj_tmpl->addVar('content', 'TOMBOL_GENERATE', $button);
			}
			$this->obj_tmpl->addVar('content', 'SISA', $rs['sisa']);
			$this->obj_tmpl->addVar('content', 'KAPASITAS', $rs['kapasitas']);
			$this->obj_tmpl->addVar('content', 'STATUS', $rs['status']);
			$this->obj_tmpl->addVar('content', 'PERIODE', $tgl);
			$this->obj_tmpl->addVar('content', 'NO_PELATIHAN', $rs['nomor_pelatihan']);
		}
	}
	//fungsi get periode tanggal pelatihan
	private function GetTanggalCourseById($id_course){
		$this->str_tgl = "";
		$rs_id = $this->obj_course->GetResourceId("GetTanggalCourseById", array($id_course, $id_course));
		if($rs_id){
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->str_tgl = $this->str_tgl.' '.$rs['tanggal'];
			}
		}
		return $this->str_tgl;
	}
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>