<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	private $obj_course;
	private $obj_notify;
	private $obj_date;
	private $obj_registrasi;
	private $obj_harga;
	private $str_stat;
	// init variabel
		
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);
				
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// business object loaded
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		$this->obj_harga= $this->obj_ctrl->LoadBusiness('course_wilayah', 'mysql', $this->arr_config['db']);
		// load javascript 
		$this->obj_ctrl->LoadJavascript('jquery-1.3.2', 'jquery.ui');
		$this->obj_ctrl->LoadJavascript('ui/ui.core', 'jquery.ui');
		$this->obj_ctrl->LoadJavascript('ui/ui.datepicker', 'jquery.ui');
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// load style
		$this->obj_ctrl->LoadStyle('base/ui.all', 'jquery.ui');
	}
	
	public function PageView(){
		//display variabel
		self::DisplayVariabel();
		// display form
		self::DisplayFormEdit();
		// display table data
		self::DisplayListData();
		// display test cookies
		self::DisplayNotification();	
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	private function DisplayVariabel(){
		//link image
		$this->obj_tmpl->addVar('content', 'JQUERY_STYLE', HTTPPATH.'doc/temp/');
		
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list-peserta', array($this->arr_routes['params'][0],$this->arr_routes['params'][1],$this->arr_routes['params'][2])));
		$this->obj_tmpl->addVar('content', 'PAGE', $this->arr_routes['params'][0]);
		
	}
	
	private function DisplayFormEdit(){
		$params = array($this->arr_routes['params'][3]);
		$result = $this->obj_course->GetDataAsSingleArray("GetDetailCourseById", $params);
		if(!empty($result)){
			$this->obj_tmpl->addVar('content', 'ID_COURSE', $result['id_course']);
			$this->obj_tmpl->addVar('content', 'TEMPAT_UTAMA', $result['tempat']);
			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);
			$this->obj_tmpl->addVar('content', 'PJ', $result['penanggung_jawab']);
			$this->obj_tmpl->addVar('content', 'TEKNISI', $result['teknisi']);
			$this->obj_tmpl->addVar('content', 'NURSE', $result['perawat']);
			$this->obj_tmpl->addVar('content', 'SESI', $result['nomor_pelatihan']);
			$this->obj_tmpl->addVar('content', 'KAPASITAS', $result['kapasitas']);
			$this->obj_tmpl->addVar('content', 'SISA', $result['sisa']);
			/*$biaya = "Rp&ensp;".number_format(intval($result['harga'])).",-";
			$this->obj_tmpl->addVar('content', 'HARGA', $biaya);*/
			$rs_city = $this->obj_harga->GetDataAsSingleArray("GetCityPenyelenggara", array($result['id_penyelenggara']));
			
		  	if(!empty($rs_city)){
				$cost = $this->obj_harga->GetDataAsSingleArray("GetCostPenyelenggaraByIdCity", array($rs_city['id_city']));
				if(!empty($cost)){
				  $this->obj_tmpl->addVar('content', 'HARGA', "Rp ". number_format($cost['biaya'],0,',','.'));
				}
			}
			$this->obj_tmpl->addVar('content', 'KOTA', self::GetNameCityById($result['id_city']));
			//get periode tanggal pelatihan
			$tgl = explode(" ", self::GetTanggalCourseById($result['id_course']));
			$tgl = $this->obj_date->GetFullDate($tgl[1])." s/d ".$this->obj_date->GetFullDate($tgl[2]);
			$this->obj_tmpl->addVar('content', 'TANGGAL', $tgl);
		}
	}
	
	private function GetNameCityById($idcity){
		$result = $this->obj_registrasi->GetDataAsSingleArray("GetCityById", array($idcity));
		return $result['city_name'];
	}
	
	// get tanggal
	private function GetTanggalCourseById($id_course){
		$this->str_tgl = "";
		$rs_id = $this->obj_course->GetResourceId("GetTanggalCourseById", array($id_course, $id_course));
		if($rs_id){
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->str_tgl = $this->str_tgl.' '.$rs['tanggal'];
			}
		}
		return $this->str_tgl;
	}
	
	private function DisplayListData(){
		// keyword nama
		if(isset($_SESSION['search']['peserta']['key_nama'])){
			$this->str_keyword = "%" . $_SESSION['search']['peserta']['key_nama'] . "%";
			$this->obj_tmpl->addVar('content', 'KEY_NAMA', $_SESSION['search']['peserta']['key_nama']);
		}else{
			$this->str_keyword = "%%";
		}
		
		// tgl_awal dan tgl_akhir
		/*
		AND e.tgl_daftar BETWEEN '%s' AND '%s'
		*/
		if(!empty($_SESSION['search']['peserta']['tgl_awal']) && !empty($_SESSION['search']['peserta']['tgl_akhir'])){
			$this->str_keytgl = "AND e.tgl_daftar BETWEEN '".$_SESSION['search']['peserta']['tgl_awal']."' AND '".$_SESSION['search']['peserta']['tgl_akhir']."'";
			$this->obj_tmpl->addVar('content', 'TGL_AWAL', $_SESSION['search']['peserta']['tgl_awal']);
			$this->obj_tmpl->addVar('content', 'TGL_AKHIR', $_SESSION['search']['peserta']['tgl_akhir']);
		}else{
			$this->str_keytgl = "";
		}
		
		// kode bayar
		if(isset($_SESSION['search']['peserta']['key_bayar'])){
			$this->str_keybayar = "%" . $_SESSION['search']['peserta']['key_bayar'] . "%";
			$this->obj_tmpl->addVar('content', 'KEY_BAYAR', $_SESSION['search']['peserta']['key_bayar']);
		}else{
			$this->str_keybayar = "%%";
		}
		
		// keyword status
		if(isset($_SESSION['search']['peserta']['stat'])){
		
			switch($_SESSION['search']['peserta']['stat']){
				case 'bayar' : 
						  $this->obj_tmpl->addVar('content', 'BAYAR', 'checked="checked"');
						  $this->str_stat = "AND e.status = 'bayar' ";
						  break;
				case 'batal' : 
						  $this->obj_tmpl->addVar('content', 'BATAL', 'checked="checked"');
						  $this->str_stat = "AND e.status = 'batal' ";
						  break;
				default  :		  
						 $this->obj_tmpl->addVar('content', 'BOOKING', 'checked="checked"');
						 $this->str_stat = " AND e.status = 'booking' ";
						 break;
			}
		}
	
		if(!isset($this->arr_routes['params'][0]))
			$page = 1;
		else
			$page = $this->arr_routes['params'][0];
		 //$this->obj_course->DebugQuery("GetCourseParticipantByParam", array($this->arr_routes['params'][3], $this->str_stat, $this->str_keyword, $this->str_keybayar, $this->str_keytgl));
		$rs_id = $this->obj_course->GetResourceId("GetCourseParticipantByParam", array($this->arr_routes['params'][3], $this->str_stat, $this->str_keyword, $this->str_keybayar, $this->str_keytgl));
		if($rs_id){
			$no = 1;
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'PREFIX', $rs['prefix']);
				$this->obj_tmpl->addVar('list_data', 'NAMA', $rs['nama']);
				$this->obj_tmpl->addVar('list_data', 'SUFFIX', $rs['suffix']);
				$this->obj_tmpl->addVar('list_data', 'TGL_DAFTAR', $this->obj_date->GetFullDate($rs['tgl_daftar']));
				$this->obj_tmpl->addVar('list_data', 'ALAMAT', $rs['alamat']);
				$this->obj_tmpl->addVar('list_data', 'KODE_BAYAR', $rs['kode_bayar']);
				$this->obj_tmpl->addVar('list_data', 'TLP', $rs['no_telp']);
				$this->obj_tmpl->addVar('list_data', 'HP', $rs['no_hp']);
				$no++;
				// link
				$url_detail = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'pdetail', array($page, $rs['id_peserta'], $rs['id_course'], $rs['id_person'],$this->arr_routes['params'][1]));
				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'phapus', array($page, $rs['id_peserta'], $rs['id_course'],$this->arr_routes['params'][1]));
				$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $url_detail);
				$this->obj_tmpl->addVar('list_data', 'URL_DELETE', $url_hapus);
				// status
				if($rs['status'] == 'booking'){
					$this->obj_tmpl->addVar('list_data', 'STATUS', 'Belum membayar');
				} else if($rs['status'] == 'bayar'){
					$this->obj_tmpl->addVar('list_data', 'STATUS', 'Sudah membayar');
				} else {
					$this->obj_tmpl->addVar('list_data', 'STATUS', 'Batal');
				}
				$this->obj_tmpl->ParseTemplate('list_data', 'a');
			}
		}
	}
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>