<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cv;
	protected $obj_course;
	protected $obj_notify;
	protected $obj_date;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();		
		/* Other object loaded below */
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);	
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
		// dhtmlgoodies_calendar loaded
		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded body event
		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");
		// loaded style
		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');			
	}
	
	public function PageView(){
		// display notification
		self::DisplayNotification();
		/* display view content */
		self::DisplayIdentitasPribadi();
		// variable display
		self::DisplayVariable();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'kota'));
	}
	
	private function DisplayIdentitasPribadi(){
		$params = array($this->arr_routes['params'][3]);
		$params_perserta = array($this->arr_routes['params'][1]);
		$result = $this->obj_cv->GetIdentitasPribadiByIdPerson($params);
		$result_peserta = $this->obj_course->GetDataAsSingleArray("GetPesertaByCourse",$params_perserta);
		if(empty($result)){
		
		}else{
			$photo = $result['photo'];
			// cek notification 
			if(isset($this->obj_notify->arr_message['field'])){
				$result = $this->obj_notify->arr_message['field'];
			}
			// parse data
			$this->obj_tmpl->addVar('content', 'ID_PERSON', $this->arr_routes['params'][3]);	
			$this->obj_tmpl->addVar('content', 'ID_CORSE', $this->arr_routes['params'][0]);	
			$this->obj_tmpl->addVar('content', 'NAMA_LENGKAP', $result['nama_lengkap']);	
			$this->obj_tmpl->addVar('content', 'TEMPAT_LAHIR', $result['tempat_lahir']);	
			$this->obj_tmpl->addVar('content', $result['jenis_kelamin'], 'selected="selected"');
			
			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);	
			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);	
			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);	
			$this->obj_tmpl->addVar('content', 'AGAMA', $result['agama']);	
			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);	
			$this->obj_tmpl->addVar('content', 'KODEPOS', $result['kodepos']);	
			$this->obj_tmpl->addVar('content', 'TELEPON', $result['telepon']);
			$this->obj_tmpl->addVar('content', 'NO_HP', $result['no_hp']);
			$this->obj_tmpl->addVar('content',  $result_peserta['ukuran'], 'selected="selected"');
			$this->obj_tmpl->addVar('content', $result_peserta['utusan'], 'checked="checked"');
			// tgl lahir		
			$tgl_lahir = explode('-', $result['tanggal_lahir']);
			$t = $tgl_lahir[0];
			$b = $tgl_lahir[1];
			$h = $tgl_lahir[2];
			$t_range = date('Y');
			$this->obj_date->SetPatTemplates($this->obj_tmpl);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year', 'list_month', 'list_day', $t, $b, $h, $t - 75, $t_range);
			
			if (isset($result['0']['tgl_mulai'])) {

			$tgl_mulai = explode('-', $result['0']['tgl_mulai']);

		} else {

			$tgl_mulai = explode('-', date("Y-m-d"));

		}
			$tm = $tgl_mulai[0];

			$bm = $tgl_mulai[1];

			$hm = $tgl_mulai[2];

		$this->obj_date->SetPatTemplates($this->obj_tmpl);

		$this->obj_date->DhtmlgoodiesStandardDate('list_year_start_a', 'list_month_start_a', 'list_day_start_a', $tm + 5 , $bm, $hm, $tm - 75, $t_range);
			// photo
			$photo_path = "doc/person/".$this->str_userid."/foto/".$photo;
			if(is_file($photo_path))
				$this->obj_tmpl->addVar('content', 'PHOTOPATH', HTTPPATH.$photo_path);
			else
				$this->obj_tmpl->addVar('content', 'PHOTOPATH', HTTPPATH."doc/temp/blank.jpg");
		}
	}
}

?>