<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	protected $obj_cpd;
	private $obj_person;
	private $obj_course;
	private $obj_notify;
	private $obj_crypt;
	private $obj_mail;
	private $obj_cv;
	private $obj_registrasi;
	private $obj_date;
	protected $int_id_log;
	private $obj_upload;
	
	// init variable
	private $arr_params;
		
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'list');	
	}
	
	protected function PageLoad(){ 
		// load business
		
		$this->obj_person = $this->obj_ctrl->LoadBusiness('person', 'mysql', $this->arr_config['db']);
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kegiatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		$this->obj_cv = $this->obj_ctrl->LoadBusiness('curriculum_vitae', 'mysql', $this->arr_config['db']);
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
		// load library
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');
		// load date function
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// load plugins mail
		$this->obj_ctrl->LoadFile('class.phpmailer.php', 'plugins/phpmailer');
		$this->obj_mail = new PHPMailer;
		
		
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'search_penyelenggara_kolektif':
				self::SearchPenyelenggaraKolektif();
				break;
			case 'reset_penyelenggara_kolektif':
				self::ResetPenyelenggaraKolektif();
				break;
			case 'search':
				self::SearchCourse();
				break;
			case 'reset':
				self::ResetCourse();
				break;
			case 'search_peserta':
				self::SearchPeserta();
				break;	
			case 'reset_peserta':
				self::ResetPeserta();
				break;
			case 'add_course':
				self::SaveCourse();
				break;
			case 'edit_course':
				self::EditCourse();
				break;
			case 'add_materi':
				self::AddMateri();
				break;
			case 'edit_materi':
				self::EditMateri();
				break;
			case 'hapus_materi':
				self::HapusMateri();
				break;	
			case 'hapus_course':
				self::HapusCourse();
				break;	
			case 'hapus_peserta':
				self::HapusPeserta();
				break;
			case 'hapus_peserta2':
				self::HapusPeserta2();
				break;	
			case 'new_code':
				self::GenerateCode();
				break;	
			case 'edit_peserta':
				self::EditPeserta();
				break;
			case 'edit_peserta2':
				self::EditPeserta2();
				break;
			case 'registrasi':
				self::InsertDataKegiatan();
				break;			
			case 'registrasi_anggota':
				self::Registrasi();
				break;	
			case 'insert':
				self::InsertDataUsulan();
				break;	
				
			case 'hadir':
				self::RegisterkehadiranPeserta();
				break;	
			case 'batal':
				self::RegisterkehadiranPesertaBatal();
				break;
					
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// fungsi search penyelenggara kolektif
	private function SearchPenyelenggaraKolektif(){
		$_SESSION['key_search'] = $this->arr_params['key_search'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'list-peserta');
		
	}
	// fungsi reset/clear session penyelenggara kolektif
	private function ResetPenyelenggaraKolektif(){
		unset($_SESSION['key_search']);
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'list-peserta');
		
		
	}
	
	// fungsi search pelatihan
	private function SearchCourse(){
		$_SESSION['search']['course']['bulan1'] = $this->arr_params['bulan1'];
		$_SESSION['search']['course']['bulan2'] = $this->arr_params['bulan2'];
		$_SESSION['search']['course']['tahun'] = $this->arr_params['tahun'];
		$_SESSION['search']['stat_admin'] = $this->arr_params['stat'];
	}
	// fungsi reset/clear session keyword
	private function ResetCourse(){
		$_SESSION['search']['course']['bulan1'] = "";
		$_SESSION['search']['course']['bulan2'] = "";
		$_SESSION['search']['course']['tahun'] = "";
		$_SESSION['search']['stat_admin'] = '';
	}
	// fungsi search peserta
	private function SearchPeserta(){
		$_SESSION['search']['peserta']['stat'] = $this->arr_params['stat'];
		$_SESSION['search']['peserta']['key_nama'] = $this->arr_params['key_nama'];
		$_SESSION['search']['peserta']['key_bayar'] = $this->arr_params['key_bayar'];
		$_SESSION['search']['peserta']['tgl_awal'] = $this->arr_params['tgl_awal'];
		$_SESSION['search']['peserta']['tgl_akhir'] = $this->arr_params['tgl_akhir'];
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'peserta', array($this->arr_params['page'], $this->arr_params['id_course']));
	}
	// fungsi reset peserta
	private function ResetPeserta(){
		$_SESSION['search']['peserta']['stat'] = "";
		$_SESSION['search']['peserta']['key_nama'] = "";
		$_SESSION['search']['peserta']['key_bayar'] = "";
		$_SESSION['search']['peserta']['tgl_awal'] = "";
		$_SESSION['search']['peserta']['tgl_akhir'] = "";
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'peserta', array($this->arr_params['page'], $this->arr_params['id_course']));
	}
	// fungsi simpan data pelatihan
	private function SaveCourse(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['penyelenggara']))
		{ $err[] = '<br /><b>Penyelenggara</b> harus diisi'; }else{$_SESSION['add']['penyelenggara'] = $this->arr_params['penyelenggara'];}
		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><b>Tempat</b> harus diisi'; }
		if(empty($this->arr_params['pj'])){ $err[] = '<br /><b>Penanggung jawab</b> harus diisi'; }
		if(empty($this->arr_params['kapasitas'])){ $err[] = '<br /><b>Kapasitas</b> harus diisi'; }
		if(empty($this->arr_params['tgl_1'])){ $err[] = '<br /><b>Tgl Hari 1</b> harus diisi'; }
		if(empty($this->arr_params['tgl_2'])){ $err[] = '<br /><b>Tgl Hari 2</b> harus diisi'; }
		if(empty($this->arr_params['tgl_3'])){ $err[] = '<br /><b>Tgl Hari 3</b> harus diisi'; }
		/*if(!is_numeric($this->arr_params['sesi'])){ $err[] = '<br /><b>Sesi pelatihan</b> harus diisi angka'; }
		// cek nomor/sesi pelatihan, syarat tidak boleh sama
		$sesi_id = $this->obj_course->GetDataAsSingleArray("CheckSesi", array($this->arr_params['sesi']));
		if($sesi_id["TOTAL"] != 0){ $err[] = '<br /><b>Sesi pelatihan</b> sudah ada'; }*/
		
		if(empty($this->arr_params['kota'])){ $err[] = '<br /><b>Kota</b> harus diisi'; }
		
		$kota = $this->obj_registrasi->GetDataAsSingleArray('GetIdCityByName', array(trim($this->arr_params['kota'])));
		//proses
        if(empty($err)){
			//parameter course_m
			$params['course'] = array($this->arr_params['penyelenggara'],
									$this->arr_params['tempat'], 
									$this->arr_params['alamat'], 
									$kota['id_city'], 
									$this->arr_params['pj'], 
									$this->arr_params['teknisi'], $this->arr_params['nurse'], 
									$this->arr_params['sesi'], $this->arr_params['tgl_1'], $this->str_userid);
			
            //print_r($params['course']);
        //die;
            
            if($this->obj_course->ProcessingData("InsertCourse", $params['course'])){
				//get id_course
				$id_course = $this->obj_course->GetLastInsertedId();
				//parameter course_data_t
				$params['course_data'] = array($id_course, $this->arr_params['kapasitas'], 
									$this->arr_params['kapasitas'], $this->str_userid);
				$this->obj_course->ProcessingData("InsertCourseData", $params['course_data']);
				//parameter jadwal
				if(!empty($this->arr_params['tgl_1'])){
					$param_1 = array($id_course, $this->arr_params['tgl_1'], 
										$this->arr_params['desc_1'], $this->str_userid);
					$this->obj_course->ProcessingData("SaveJadwal_1", $param_1);
				}
				if(!empty($this->arr_params['tgl_2'])){
					$param_2 = array($id_course, $this->arr_params['tgl_2'], 
										$this->arr_params['desc_2'], $this->str_userid);
					$this->obj_course->ProcessingData("SaveJadwal_2", $param_2);
				}
				if(!empty($this->arr_params['tgl_3'])){
					$param_3 = array($id_course, $this->arr_params['tgl_3'], 
										$this->arr_params['desc_3'], $this->str_userid);
					$this->obj_course->ProcessingData("SaveJadwal_3", $param_3);
				}
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			}else{
			
				$filled = array("ID_PENYELENGGARA" => $this->arr_params['penyelenggara'], 
								"TEMPAT" => $this->arr_params['tempat'], 
								"ALAMAT" => $this->arr_params['alamat'], 
								"KOTA" => $this->arr_params['kota'], 
								"PJ" => $this->arr_params['pj'], 
								"TEKNISI" => $this->arr_params['teknisi'], 
								"NURSE" => $this->arr_params['nurse'], 
								"SESI" => $this->arr_params['sesi'], 
								"KAPASITAS" => $this->arr_params['kapasitas'], 
								"TGL_1" => $this->arr_params['tgl_1'], 
								"TGL_2" => $this->arr_params['tgl_2'], 
								"TGL_3" => $this->arr_params['tgl_3'], 
								"DESC_1" => $this->arr_params['desc_1'], 
								"DESC_2" => $this->arr_params['desc_2'], 
								"DESC_3" => $this->arr_params['desc_2']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_PENYELENGGARA" => $this->arr_params['penyelenggara'],
								"TEMPAT" => $this->arr_params['tempat'], 
								"ALAMAT" => $this->arr_params['alamat'], 
								"KOTA" => $this->arr_params['kota'], 
								"PJ" => $this->arr_params['pj'], 
								"TEKNISI" => $this->arr_params['teknisi'], 
								"NURSE" => $this->arr_params['nurse'], 
								"SESI" => $this->arr_params['sesi'], 
								"KAPASITAS" => $this->arr_params['kapasitas'],
								"TGL_1" => $this->arr_params['tgl_1'], 
								"TGL_2" => $this->arr_params['tgl_2'], 
								"TGL_3" => $this->arr_params['tgl_3'], 
								"DESC_1" => $this->arr_params['desc_1'], 
								"DESC_2" => $this->arr_params['desc_2'], 
								"DESC_3" => $this->arr_params['desc_2']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'add');		
	}
	// fungsi edit data pelatihan dan simpan, edit, delete data tanggal pelatihan
	private function EditCourse(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['penyelenggara'])){ $err[] = '<br /><b>Penyelenggara</b> harus diisi'; }
		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><b>Tempat</b> harus diisi'; }
		if(empty($this->arr_params['pj'])){ $err[] = '<br /><b>Penanggung jawab</b> harus diisi'; }
		if(empty($this->arr_params['sesi'])){ $err[] = '<br /><b>Sesi pelatihan</b> harus diisi'; }
		if(empty($this->arr_params['kapasitas'])){ $err[] = '<br /><b>Kapasitas</b> harus diisi'; }
		if(!is_numeric($this->arr_params['sesi'])){ $err[] = '<br /><b>Sesi pelatihan</b> harus diisi angka'; }
		if(empty($this->arr_params['verifikasi'])){ $err[] = '<br /><b>Status Verifikasi</b> harus diisi'; }
		// cek nomor/sesi pelatihan, syarat tidak boleh sama
		if($this->arr_params['sesi_id'] != $this->arr_params['sesi']){
			$sesi_id = $this->obj_course->GetDataAsSingleArray("CheckSesi", array($this->arr_params['sesi']));
			if($sesi_id["TOTAL"] != 0){ $err[] = '<br /><b>Sesi pelatihan</b> sudah ada'; }
		}
		if(empty($this->arr_params['kota'])){ $err[] = '<br /><b>Kota</b> harus diisi'; }
		
		$kota = $this->obj_registrasi->GetDataAsSingleArray('GetIdCityByName', array(trim($this->arr_params['kota'])));
		// proses
		if(empty($err)){
			//parameter course_m
			
			$params['course'] = array($this->arr_params['penyelenggara'],$this->arr_params['tempat'], $this->arr_params['alamat'], 
									$kota['id_city'], 
									$this->arr_params['pj'], 
									$this->arr_params['teknisi'], $this->arr_params['nurse'], 
									$this->arr_params['sesi'],$this->arr_params['verifikasi'],
									 $this->str_userid, 
									$this->arr_params['id_course']);
			$params['course_data'] = array($this->arr_params['kapasitas'], $this->str_userid, 
									$this->arr_params['id_course']);
			if($this->obj_course->UpdateCourse($params)){
				if(!empty($this->arr_params['id_jdwl1'])){
					$param['jadwal_1'] = array($this->arr_params['tgl_1'], 
												$this->arr_params['desc_1'], 
												$this->str_userid, $this->arr_params['id_jdwl1']);
					if(!empty($this->arr_params['tgl_1'])){
						$this->obj_course->ProcessingData("UpdateJadwal1", $param['jadwal_1']);
					} else {
						$this->obj_course->ProcessingData("DeleteJadwal", array($this->arr_params['id_jdwl1']));
					}
				}
				if(!empty($this->arr_params['id_jdwl2'])){
					$param['jadwal_2'] = array($this->arr_params['tgl_2'], 
												$this->arr_params['desc_2'], 
												$this->str_userid, $this->arr_params['id_jdwl2']);
					if(!empty($this->arr_params['tgl_2'])){
						$this->obj_course->ProcessingData("UpdateJadwal2", $param['jadwal_2']);
					} else {
						$this->obj_course->ProcessingData("DeleteJadwal", array($this->arr_params['id_jdwl2']));
					}		
				}
				if(!empty($this->arr_params['id_jdwl3'])){
					$param['jadwal_3'] = array($this->arr_params['tgl_3'], 
												$this->arr_params['desc_3'], 
												$this->str_userid, $this->arr_params['id_jdwl3']);
					if(!empty($this->arr_params['tgl_3'])){
						$this->obj_course->ProcessingData("UpdateJadwal3", $param['jadwal_3']);
					} else {
						$this->obj_course->ProcessingData("DeleteJadwal", array($this->arr_params['id_jdwl3']));
					}
				}
				
				if(empty($this->arr_params['id_jdwl3']) && !empty($this->arr_params['tgl_3'])){
					$param_ins_3 = array($this->arr_params['id_course'], 
										$this->arr_params['tgl_3'], $this->arr_params['desc_3'], 
										$this->str_userid);
					$this->obj_course->ProcessingData("SaveJadwal_3", $param_ins_3);
				}
				
				if(empty($this->arr_params['id_jdwl2']) && !empty($this->arr_params['tgl_2'])){
					$param_ins_2 = array($this->arr_params['id_course'], 
										$this->arr_params['tgl_2'], $this->arr_params['desc_2'], 
										$this->str_userid);
					$this->obj_course->ProcessingData("SaveJadwal_2", $param_ins_2);
				}
				
				if(empty($this->arr_params['id_jdwl1']) && !empty($this->arr_params['tgl_1'])){
					$param_ins_1 = array($this->arr_params['id_course'], 
										$this->arr_params['tgl_1'], $this->arr_params['desc_1'], 
										$this->str_userid);
					$this->obj_course->ProcessingData("SaveJadwal_1", $param_ins_1);
				}
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			}else{
				$filled = array("TEMPAT" => $this->arr_params['tempat'], 
								"ALAMAT" => $this->arr_params['alamat'], 
								"KOTA" => $this->arr_params['kota'], 
								"PJ" => $this->arr_params['pj'], 
								"TEKNISI" => $this->arr_params['teknisi'], 
								"NURSE" => $this->arr_params['nurse'], 
								"SESI" => $this->arr_params['sesi'], 
								"KAPASITAS" => $this->arr_params['kapasitas'], 
								"TGL_1" => $this->arr_params['tgl_1'], 
								"TGL_2" => $this->arr_params['tgl_2'], 
								"TGL_3" => $this->arr_params['tgl_3'], 
								"DESC_1" => $this->arr_params['desc_1'], 
								"DESC_2" => $this->arr_params['desc_2'], 
								"DESC_3" => $this->arr_params['desc_3']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("TEMPAT" => $this->arr_params['tempat'], 
								"ALAMAT" => $this->arr_params['alamat'], 
								"KOTA" => $this->arr_params['kota'], 
								"PJ" => $this->arr_params['pj'], 
								"TEKNISI" => $this->arr_params['teknisi'], 
								"NURSE" => $this->arr_params['nurse'], 
								"SESI" => $this->arr_params['sesi'], 
								"KAPASITAS" => $this->arr_params['kapasitas'],
								"TGL_1" => $this->arr_params['tgl_1'], 
								"TGL_2" => $this->arr_params['tgl_2'], 
								"TGL_3" => $this->arr_params['tgl_3'], 
								"DESC_1" => $this->arr_params['desc_1'], 
								"DESC_2" => $this->arr_params['desc_2'], 
								"DESC_3" => $this->arr_params['desc_3']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'edit', array($this->arr_params['page'], $this->arr_params['id_course']));
	}
	// fungsi tambah materi
	private function AddMateri(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['start_time'])){ $err[] = '<br /><b>Jam mulai</b> harus diisi'; }
		if(empty($this->arr_params['end_time'])){ $err[] = '<br /><b>Jam selesai</b> harus diisi'; }
		if(empty($this->arr_params['module'])){ $err[] = '<br /><b>Materi</b> harus diisi'; }
		if(empty($this->arr_params['instruktur'])){ $err[] = '<br /><b>Instruktur</b> harus diisi'; }
		
		//proses
		if(empty($err)){
			//parameter materi
			$id_instruktur = $this->obj_course->GetDataAsSingleArray("GetIDInstruktur", array($this->arr_params['instruktur']));
			//echo $id_instruktur['id_instruktur'];exit;
			$params['materi'] = array($this->arr_params['id_jdwl'], 
									$this->arr_params['start_time'], 
									$this->arr_params['end_time'], $this->arr_params['module'], 
									$id_instruktur['id_instruktur'], $this->str_userid);
			if($this->obj_course->ProcessingData("InsertMateri", $params['materi'])){
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			}else{
				$filled = array("START_TIME" => $this->arr_params['start_time'], 
								"END_TIME" => $this->arr_params['end_time'], 
								"MATERI" => $this->arr_params['module'], 
								"INSTRUKTUR" => $this->arr_params['instruktur']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("START_TIME" => $this->arr_params['start_time'], 
								"END_TIME" => $this->arr_params['end_time'], 
								"MATERI" => $this->arr_params['module'], 
								"INSTRUKTUR" => $this->arr_params['instruktur']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'materi', array($this->arr_params['page'], $this->arr_params['id_course'], $this->arr_params['id_jdwl']));
	}
	// fungsi edit materi
	private function EditMateri(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['start_time'])){ $err[] = '<br /><b>Jam mulai</b> harus diisi'; }
		if(empty($this->arr_params['end_time'])){ $err[] = '<br /><b>Jam selesai</b> harus diisi'; }
		if(empty($this->arr_params['module'])){ $err[] = '<br /><b>Materi</b> harus diisi'; }
		if(empty($this->arr_params['instruktur'])){ $err[] = '<br /><b>Instruktur</b> harus diisi'; }
		
		//proses
		if(empty($err)){
			//parameter materi
			$id_instruktur = $this->obj_course->GetDataAsSingleArray("GetIDInstruktur", array($this->arr_params['instruktur']));
			//echo $id_instruktur['id_instruktur'];exit;
			$params['materi'] = array($this->arr_params['start_time'], 
									$this->arr_params['end_time'], $this->arr_params['module'], 
									$id_instruktur['id_instruktur'], $this->str_userid, 
									$this->arr_params['id_materi']);
			if($this->obj_course->ProcessingData("EditMateri", $params['materi'])){
				self::SendNotification($err, $filled, 'Data has been edited.', 'success');
			}else{
				$filled = array("START_TIME" => $this->arr_params['start_time'], 
								"END_TIME" => $this->arr_params['end_time'], 
								"MATERI" => $this->arr_params['module'], 
								"INSTRUKTUR" => $this->arr_params['instruktur']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("START_TIME" => $this->arr_params['start_time'], 
								"END_TIME" => $this->arr_params['end_time'], 
								"MATERI" => $this->arr_params['module'], 
								"INSTRUKTUR" => $this->arr_params['instruktur']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'medit', array($this->arr_params['page'], $this->arr_params['id_course'], $this->arr_params['id_jdwl'], $this->arr_params['id_materi']));
	}
	// fungsi hapus materi
	private function HapusMateri(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['id_materi'])){ $err[] = '<br /><b>ID Materi</b> kosong'; }
		
		//proses
		if(empty($err)){
			//parameter materi
			if($this->obj_course->ProcessingData("DeleteMateri", array(
																$this->arr_params['id_materi']))){
				self::SendNotification($err, $filled, 'Data has been deleted.', 'success');
			}else{
				$filled = array("ID_MATERI" => $this->arr_params['id_materi']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_MATERI" => $this->arr_params['id_materi']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'materi', array($this->arr_params['page'], $this->arr_params['id_course'], $this->arr_params['id_jdwl']));
	}
	// fungsi hapus course
	private function HapusCourse(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['id_course'])){ $err[] = '<br /><b>ID Course</b> kosong'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><b>Page</b> kosong'; }
		//proses
		if(empty($err)){
			//parameter materi
			if($this->obj_course->ProcessingData("DeleteCourse", array(
																$this->arr_params['id_course']))){
				self::SendNotification($err, $filled, 'Data has been deleted.', 'success');
			}else{
				$filled = array("ID_COURSE" => $this->arr_params['id_course']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_COURSE" => $this->arr_params['id_course']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'list', array($this->arr_params['page']));
	}	
	
	//fungsi hapus peserta kolektif
	private function HapusPeserta(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['id_peserta'])){ $err[] = '<br /><b>ID Peserta</b> kosong'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><b>Page</b> kosong'; }
		if(empty($this->arr_params['id_course'])){ $err[] = '<br /><b>ID Course</b> kosong'; }
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><b>ID Person</b> kosong'; }
		//proses
		if(empty($err)){
			//parameter materi
			if($this->obj_course->ProcessingData("DeletePeserta", array(
																$this->arr_params['id_peserta']))){
				self::SendConfirmationDeleteCourse($this->arr_params['id_person'], $this->arr_params['no_pelatihan']);
				self::SendNotification($err, $filled, 'Data has been deleted.', 'success');
			}else{
				$filled = array("ID_PESERTA" => $this->arr_params['id_peserta']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_PESERTA" => $this->arr_params['id_peserta']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'peserta-kolektif', array($this->arr_params['page'], $this->arr_params['id_course']));
	}
	
	//fungsi hapus peserta individu
	private function HapusPeserta2(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['id_peserta'])){ $err[] = '<br /><b>ID Peserta</b> kosong'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><b>Page</b> kosong'; }
		if(empty($this->arr_params['id_course'])){ $err[] = '<br /><b>ID Course</b> kosong'; }
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><b>ID Person</b> kosong'; }
		//proses
		if(empty($err)){
			//parameter materi
			if($this->obj_course->ProcessingData("DeletePeserta", array(
																$this->arr_params['id_peserta']))){
				self::SendConfirmationDeleteCourse($this->arr_params['id_person'], $this->arr_params['no_pelatihan']);
				self::SendNotification($err, $filled, 'Data has been deleted.', 'success');
			}else{
				$filled = array("ID_PESERTA" => $this->arr_params['id_peserta']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_PESERTA" => $this->arr_params['id_peserta']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list-peserta', array('peserta', $this->arr_params['page']));
	}
	
	//fungsi generate kode bayar
	private function GenerateCode(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['id_peserta'])){ $err[] = '<br /><b>ID Peserta</b> kosong'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><b>Page</b> kosong'; }
		if(empty($this->arr_params['id_course'])){ $err[] = '<br /><b>ID Course</b> kosong'; }
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><b>ID Person</b> kosong'; }
		if(empty($err)){
			$rand_1 = mt_rand(1, 1000);
			$rand_2 = mt_rand(1, 500);
			$hash_key1 = $this->obj_crypt->CreateUserKey($rand_1);
			$hash_key2 = $this->obj_crypt->CreateUserKey($rand_2);
			//ambil masing2 6 digit
			$sub_key1 = substr($hash_key1, 0, 6);
			$sub_key2 = substr($hash_key2, 0, 6);
			//menyatukan masing2 sub menjadi 12 digit
			$kode_byr = $sub_key1.$sub_key2;
			//update kode bayar
			$params['generate'] = array($kode_byr, $this->arr_params['id_peserta']);
			//parameter materi
			if($this->obj_course->ProcessingData("UpdatePaymentCode", $params['generate'])){
				self::SendConfirmationUpdateCode($this->arr_params['id_person'], $kode_byr, $this->arr_params['no_pelatihan']);
				self::SendNotification($err, $filled, 'Data has been update.', 'success');
			}else{
				$filled = array("ID_PESERTA" => $this->arr_params['id_peserta'], 
									"PAGE" => $this->arr_params['page'], 
									"ID_COURSE" => $this->arr_params['id_course'], 
									"ID_PERSON" => $this->arr_params['id_person'], 
									"TGL_BATAS" => $this->arr_params['tgl_batas']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_PESERTA" => $this->arr_params['id_peserta'], 
									"PAGE" => $this->arr_params['page'], 
									"ID_COURSE" => $this->arr_params['id_course'], 
									"ID_PERSON" => $this->arr_params['id_person'], 
									"TGL_BATAS" => $this->arr_params['tgl_batas']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'pdetail', array($this->arr_params['page'], $this->arr_params['id_peserta'], $this->arr_params['id_course'], $this->arr_params['id_person']));
	}
	
	//proses edit peserta kolektif
	private function EditPeserta(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['id_peserta'])){ $err[] = '<br /><b>ID Peserta</b> kosong'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><b>Page</b> kosong'; }
		if(empty($this->arr_params['id_course'])){ $err[] = '<br /><b>ID Course</b> kosong'; }
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><b>ID Person</b> kosong'; }
		if(empty($this->arr_params['tgl_batas'])){ $err[] = '<br /><b>Batas akhir pembayaran</b> masih kosong'; }
		//if(empty($this->arr_params['id_penyelenggara'])){ $err[] = '<br /><b>ID Penyelenggara</b> masih kosong'; }
		
		if(empty($err)){
			//update var peserta
			$params['peserta'] = array($this->arr_params['status'], $this->arr_params['tgl_batas'], $this->arr_params['id_peserta']);
			//parameter materi
			if($this->obj_course->ProcessingData("UpdatePeserta", $params['peserta'])){
				if($this->arr_params['status'] != $this->arr_params['status_old']){
					if($this->arr_params['status_old'] == 'bayar' && $this->arr_params['status'] == 'batal'){
						if($this->arr_params['sisa'] != $this->arr_params['kapasitas']){
							$params['bayar'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("TambahSisa", $params['bayar']);
						}
					}
					if($this->arr_params['status_old'] == 'batal' && $this->arr_params['status'] == 'bayar'){
						if($this->arr_params['sisa'] != 0){
							$params['sisa'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("KurangSisa", $params['sisa']);
						}
					}
					if($this->arr_params['status_old'] == 'bayar' && $this->arr_params['status'] == 'booking'){
						if($this->arr_params['sisa'] != $this->arr_params['kapasitas']){
							$params['bayar'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("TambahSisa", $params['bayar']);
							//---
							$params = array('1', $this->arr_params['id_person'], $this->arr_params['id_person']);
							if($this->obj_person->ProcessingData("UpdateStatus", $params)){
								// try to send mail
								$stat = 'Aktif';
								if(!self::SendEmailStatus($stat)){
									$err[] = '<br /><b>Email</b> tidak dapat terkirim';
								}
							}	
							//---
							
						}
					}
					if($this->arr_params['status_old'] == 'booking' && $this->arr_params['status'] == 'bayar'){
						if($this->arr_params['sisa'] != 0){
							$params['sisa'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("KurangSisa", $params['sisa']);
						}
					}
				}
				self::SendConfirmationStatusPayment($this->arr_params['id_peserta'], $this->arr_params['id_course'], $this->arr_params['id_person'], $this->arr_params['status'], $this->arr_params['tgl_batas'], $this->arr_params['no_pelatihan']);
				self::SendNotification($err, $filled, 'Data has been edited.', 'success');
			}else{
				$filled = array("ID_PESERTA" => $this->arr_params['id_peserta'], 
									"PAGE" => $this->arr_params['page'], 
									"ID_COURSE" => $this->arr_params['id_course'], 
									"ID_PERSON" => $this->arr_params['id_person'], 
									"TGL_BATAS" => $this->arr_params['tgl_batas']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_PESERTA" => $this->arr_params['id_peserta'], 
									"PAGE" => $this->arr_params['page'], 
									"ID_COURSE" => $this->arr_params['id_course'], 
									"ID_PERSON" => $this->arr_params['id_person'], 
									"TGL_BATAS" => $this->arr_params['tgl_batas']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'pdetail', array($this->arr_params['page'], $this->arr_params['id_peserta'], $this->arr_params['id_course'], $this->arr_params['id_person'],$this->arr_params['id_penyelenggara']));
	}
	
	//proses edit peserta individu
	private function EditPeserta2(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		// verifikasi variabel yang harus diisi
		if(empty($this->arr_params['id_peserta'])){ $err[] = '<br /><b>ID Peserta</b> kosong'; }
		if(empty($this->arr_params['page'])){ $err[] = '<br /><b>Page</b> kosong'; }
		if(empty($this->arr_params['id_course'])){ $err[] = '<br /><b>ID Course</b> kosong'; }
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><b>ID Person</b> kosong'; }
		if(empty($this->arr_params['tgl_batas'])){ $err[] = '<br /><b>Batas akhir pembayaran</b> masih kosong'; }

		
		if(empty($err)){
			//update var peserta
			$params['peserta'] = array($this->arr_params['status'], $this->arr_params['tgl_batas'], $this->arr_params['id_peserta']);
			//parameter materi
			if($this->obj_course->ProcessingData("UpdatePeserta", $params['peserta'])){
				if($this->arr_params['status'] != $this->arr_params['status_old']){
					if($this->arr_params['status_old'] == 'bayar' && $this->arr_params['status'] == 'batal'){
						if($this->arr_params['sisa'] != $this->arr_params['kapasitas']){
							$params['bayar'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("TambahSisa", $params['bayar']);
						}
					}
					if($this->arr_params['status_old'] == 'batal' && $this->arr_params['status'] == 'bayar'){
						if($this->arr_params['sisa'] != 0){
							$params['sisa'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("KurangSisa", $params['sisa']);
						}
					}
					if($this->arr_params['status_old'] == 'bayar' && $this->arr_params['status'] == 'booking'){
						if($this->arr_params['sisa'] != $this->arr_params['kapasitas']){
							$params['bayar'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("TambahSisa", $params['bayar']);
							
							//---
							$params = array('1', $this->arr_params['id_person'], $this->arr_params['id_person']);
							if($this->obj_person->ProcessingData("UpdateStatus", $params)){
								// try to send mail
								$stat = 'Aktif';
								if(!self::SendEmailStatus($stat)){
									$err[] = '<br /><b>Email</b> tidak dapat terkirim';
								}
							}	
							//---
							
							
						}
					}
					if($this->arr_params['status_old'] == 'booking' && $this->arr_params['status'] == 'bayar'){
						if($this->arr_params['sisa'] != 0){
							$params['sisa'] = array(1, $this->arr_params['id_course']);
							$this->obj_course->ProcessingData("KurangSisa", $params['sisa']);
						}
					}
				}
				self::SendConfirmationStatusPayment($this->arr_params['id_peserta'], $this->arr_params['id_course'], $this->arr_params['id_person'], $this->arr_params['status'], $this->arr_params['tgl_batas'], $this->arr_params['no_pelatihan']);
				self::SendNotification($err, $filled, 'Data has been edited.', 'success');
			}else{
				$filled = array("ID_PESERTA" => $this->arr_params['id_peserta'], 
									"PAGE" => $this->arr_params['page'], 
									"ID_COURSE" => $this->arr_params['id_course'], 
									"ID_PERSON" => $this->arr_params['id_person'], 
									"TGL_BATAS" => $this->arr_params['tgl_batas']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure', 'error');
			}
		}else{
			$filled = array("ID_PESERTA" => $this->arr_params['id_peserta'], 
									"PAGE" => $this->arr_params['page'], 
									"ID_COURSE" => $this->arr_params['id_course'], 
									"ID_PERSON" => $this->arr_params['id_person'], 
									"TGL_BATAS" => $this->arr_params['tgl_batas']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
		}
		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'],'pdetail2', array('peserta',$this->arr_params['page'], $this->arr_params['id_peserta'], $this->arr_params['id_course'], $this->arr_params['id_person'],$this->arr_params['id_penyelenggara']));
	}
	
	
	private function SendEmailStatus($stat){
		// get detail member
		$params = array($this->arr_params['id_person']);
		$rs = $this->obj_registrasi->GetDataAsSingleArray("GetDetailPersonById", $params);
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>".$this->arr_config['web']['title']."</h3>
						<h3>Control Panel</h3>
						<p><strong>".$rs['prefix'].' '.$rs['nama'].' '.$rs['suffix']."</strong>,<br>
						Email ini memberikan konfirmasi kepada anda bahwa Status anda dalam web ACLS telah berhasil diubah menjadi : <strong>".$stat."</strong>.<br></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Perubahan kata kunci (password)";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($rs['email'], $rs['nama']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	private function SendConfirmationStatusPayment($idpeserta, $id_course, $id_person, $status, $tgl_batas, $no_pelatihan){
		// get detail member
		$params = array($id_person);
		$rs = $this->obj_registrasi->GetDataAsSingleArray("GetDetailPersonById", $params);
		
		$pass_valid = $this->obj_crypt->StandardDecrypt($rs['pass'], $rs['hash_key']);
		
		$course = $this->obj_course->GetDataAsSingleArray("GetInfoCourseById", array($id_course));
		$tgl_course = $this->obj_course->GetResourceId("GetTglCourseById", array($id_course, $id_course));
		$peserta =  $this->obj_course->GetDataAsSingleArray("GetPesertaById_1", array($idpeserta));
		$tgl_kursus ='';
		$splt = '';
		while($rec = mysqli_fetch_assoc($tgl_course)){
			$splt='#';
			$tgl_kursus .= $rec['tanggal'].$splt;
			
		}
		$ex_tglkursus = explode("#", $tgl_kursus);
		
		// init status
		if($status == 'booking'){
			$stat = 'Belum Membayar';
		}else if($status == 'bayar'){
			$stat = 'Telah Membayar';
		}else{
			$stat = 'Batal';
		}
		// init tgl
		if($status == 'booking'){
			$tgl = "<br><strong>Batas Akhir Pembayaran ".$this->obj_date->GetFullDate($tgl_batas)."</strong>.";
		} else {
			$tgl = '';
		}
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 800px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>".$this->arr_config['web']['title']."</h3>
						<br />
						<p>Yang Terhormat ".$rs['prefix'].' '.$rs['nama'].' '.$rs['suffix'].", </p>
						<p align=\"justify\">Terima kasih anda telah melakukan pembayaran untuk mengikuti Pelatihan ACLS dengan keterangan sebagai berikut :</p>
						<br />
						<p><strong>Rincian Pembayaran</p></strong>
						<p>Kode Pembayaran : ".$peserta['kode_bayar']."</p>
						<p>Jumlah Pembayaran : Rp ".number_format($course['biaya'],0,',','.')."</p>
						<p>Status : ".$stat ."</p>
						<br />
						<p><strong>Jadwal Pelatihan ACLS</p></strong>
						<p>Pelatihan ACLS : ke-".$course['nomor_pelatihan']."</p>
						<p>Penyelenggara : ".$course['nama']."</p>
						<p>Tanggal Pelatihan : ".$this->obj_date->GetFullDate($ex_tglkursus[0])." s/d ".$this->obj_date->GetFullDate($ex_tglkursus[1])."</p>
						<br />
						<p><strong>Akses Aplikasi ACLS :</p></strong>
						<p>Username : ".$rs['userid']."</p>
						<p>Password : ".$pass_valid."</p>
						<br />
						<p align=\"justify\">Selanjutnya silahkan anda login dengan username dan password anda untuk dapat menggunakan fasilitas dalam aplikasi ACLS di <a href=\"http://www.acls-indonesia.com\">http://www.acls-indonesia.com</a> atau silahkan klik tautan berikut ini :</p>
						<p><a href=\"http://www.acls-indonesia.com/index.php?log=254a6sadfas68a1sdfa\">http://www.acls-indonesia.com/index.php?log=254a6sadfas68a1sdfa</a></p>
						<p align=\"justify\">Terima kasih.</p>
						<br /><br />
						<p>Hormat Kami,</p>
						<br />
						<p>ACLS Indonesia - PERKI</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Perubahan Data Pendaftaran Pelatihan ACLS";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($rs['email'], $rs['nama']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	private function SendConfirmationUpdateCode($id_person, $kode_byr, $no_pelatihan){
		// get detail member
		$params = array($id_person);
		$rs = $this->obj_registrasi->GetDataAsSingleArray("GetDetailPersonById", $params);
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>".$this->arr_config['web']['title']."</h3>
						<h3>Control Panel</h3>
						<p><strong>".$rs['prefix'].' '.$rs['nama'].' '.$rs['suffix']."</strong>,<br>
						Email ini memberikan konfirmasi kepada anda bahwa Kode Bayar untuk pelatihan ACLS ke-".$no_pelatihan." telah berhasil diubah sebagai berikut : <strong>".$kode_byr."</strong>.<br></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Perubahan Data Pendaftaran Pelatihan ACLS";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($rs['email'], $rs['nama']);		
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	private function SendConfirmationDeleteCourse($id_person, $no_pelatihan){
		// get detail member
		$params = array($id_person);
		$rs = $this->obj_registrasi->GetDataAsSingleArray("GetDetailPersonById", $params);
		// body
		$body	= "<body bgcolor=\"#CCCCCC\">
					<style>
					.page {
						margin: auto;
						padding: 5px 5px 5px 5px;
						width: 400px;
						background-color: #FFFFFF;
						border: 1px solid #999999;
						font-family: Verdana, Arial, Helvetica, sans-serif;
					}
					.page p {
						margin: 0px 0px 10px 0px;
						font-size: 11px;
						line-height: 16px;
					}
					.page H3 {
						margin: 0px 0px 10px 0px;
						font-size: 12px;
					}
					</style>
					<div class=\"page\">
						<h3>".$this->arr_config['web']['title']."</h3>
						<h3>Control Panel</h3>
						<p><strong>".$rs['prefix'].' '.$rs['nama'].' '.$rs['suffix']."</strong>,<br>
						Email ini memberikan konfirmasi kepada anda bahwa data anda sebagai peserta pelatihan ACLS ke-".$no_pelatihan." pada web aplikasi ACLS telah dihapus<br></p>
						<p>Terima kasih.</p>
					</div>
					</body>";	
		// $body             = $this->obj_mail->getFile('doc/mail/contents.html');
		$body             = eregi_replace("[\]",'',$body);
		// this script will auto generate setting
		$this->obj_mail->IsSMTP();
		$this->obj_mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$this->obj_mail->SMTPSecure = "ssl";                 				// sets the prefix to the servier
		$this->obj_mail->Host       = $this->arr_system_default['smtp_host'];    	// sets GMAIL as the SMTP server
		$this->obj_mail->Port       = $this->arr_system_default['smtp_port'];    	// set the SMTP port for the GMAIL server		
		$this->obj_mail->Username   = $this->arr_system_default['smtp_username'];    // GMAIL username
		$this->obj_mail->Password   = $this->arr_system_default['smtp_password'];    // GMAIL password		
		$this->obj_mail->AddReplyTo($this->arr_system_default['siteemail'], $this->arr_system_default['sitename']);		
		$this->obj_mail->From       = $this->arr_system_default['siteemail'];
		$this->obj_mail->FromName   = $this->arr_system_default['sitename'];		
		$this->obj_mail->Subject    = "Penghapusan Data Peserta";		
		//$this->obj_mail->Body       = "Hi,<br>This is the HTML BODY<br>";                      
		//HTML Body
		$this->obj_mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; 
		// optional, comment out and test
		$this->obj_mail->WordWrap   = 50; // set word wrap		
		$this->obj_mail->MsgHTML($body);		
		$this->obj_mail->AddAddress($rs['email'], $rs['nama']);
		// $this->obj_mail->AddAttachment("images/phpmailer.gif");             // attachment
		$this->obj_mail->IsHTML(true); // send as HTML		
		if(!$this->obj_mail->Send())
			return false;
		else
			return true;
	}
	
	private function InsertDataKegiatan(){	
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// get id log
		$result = $this->obj_cpd->GetDataAsSingleArray("GetLastIdBukuLog", array());
		$this->int_id_log = $result['last'];
		//$this->obj_course->DebugQuery("GetCourseByParamPelatihan", array($this->arr_params['id_corse']));exit;
		$result_pelatihan = $this->obj_course->GetDataAsSingleArray("GetCourseByParamPelatihan", array($this->arr_params['id_corse']));
		//print_r($result_pelatihan);exit;
		// ----------------------------------------------------------------
		// Mendapatkan form aktif yang dipakai ----------------------------
		$params_perserta = $this->arr_params['id_person'];
		$int_id_form=2;
		if($this->arr_params['status_kepesertaan']=='peserta'){
		$nilai=$result_pelatihan['skp_peserta'];
		}elseif($this->arr_params['status_kepesertaan']=='panitia'){
		$nilai=$result_pelatihan['skp_panitia'];
		}elseif($this->arr_params['status_kepesertaan']=='moderator'){
		$nilai=$result_pelatihan['skp_moderator'];
		}elseif($this->arr_params['status_kepesertaan']=='narasumber'){
		$nilai=$result_pelatihan['skp_narasumber'];
		}
		//$param_kepesertaan=$this->arr_params['status_kepesertaan'];
		$status="yes";
		//print_r($this->arr_params['status_kepesertaan']);exit;
		$tgl_kegiatan=$result_pelatihan['tgl_mulai'];
		
		

    $data_xml0 ="<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
    $data_xml1 ="<data><item><idt>7</idt><value>";
	$data_xml1a =$this->arr_params['status_kepesertaan'];
	$data_xml1b ="</value></item><item><idt>76</idt><value>";
	$sk_kegiatan=$result_pelatihan['nomor_pelatihan'];
    $data_xml2="</value></item><item><idt>77</idt><value>";
	$jpl_kegiatan=$result_pelatihan['jml_jpl'];
    $data_xml3="</value></item><item><idt>9</idt><value>";
	$judul_kegiatan=$result_pelatihan['nama_course'];
    $data_xml4="</value></item><item><idt>10</idt><value>";
	$tempat_kegiatan=$result_pelatihan['tempat'];
	$data_xml5="</value></item><item><idt>11</idt><value>";
	$penyelenggara_kegiatan=$result_pelatihan['unit_kerja'];
	$data_xml6="</value></item><item><idt>12</idt><value>102</value></item></data>";
    $data=$data_xml0.$data_xml1.$data_xml1a.$data_xml1b.$sk_kegiatan.$data_xml2.$jpl_kegiatan.$data_xml3.$judul_kegiatan.$data_xml4.$tempat_kegiatan.$data_xml5.$penyelenggara_kegiatan.$data_xml6;
	
		/*$data = '<?xml version=\"1.0\" encoding=\"UTF-8\"?><data><item><idt>7</idt><value>Peserta</value></item><item><idt>76</idt><value>sk Kegiatan</value></item><item><idt>77</idt><value>3</value></item><item><idt>9</idt><value>$judul_kegiatan</value></item><item><idt>10</idt><value>Hotel Inna Padang</value></item><item><idt>11</idt><value>DPD IPAI MAKASAR</value></item><item><idt>12</idt><value>100</value></item></data>';*/
		// ----------------------------------------------------------------
		// mendapatkan nilai skp dari skp engine --------------------------
		
	
		// ----------------------------------------------------------------
		// processing -----------------------------------------------------
		if(empty($err)){
			$params = array($this->int_id_log,$int_id_form,$params_perserta, $data, $nilai, $tgl_kegiatan, $status,$this->str_userid,$this->str_userid);
			//print_r($params );exit;
			// execute process
			//$this->obj_cpd->Debugquery("InsertDataKegiatanByadmin", $params);exit;
			if($this->obj_cpd->ProcessingRawData("InsertDataKegiatanByadmin", $params)){
				// upload file
				//$err_file = self::UploadDokumenBukti($_FILES);
				$err = array_merge($err, $err_file);
				// notification message	
				$err[] = '<br />Nilai SKP yang diperoleh adalah <strong>'.$nilai.' SKP</strong>'; 
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// save history
				$history['user'] = $params_perserta;
				$history['target'] = "member";
				$history['title'] = "Pencatatan kegiatan P2KB";
				$history['deskripsi'] = $nama_kegiatan . ' ('.$nilai.' SKP)';
				$history['url_title'] = "Buku Log";
				$history['url_link'] = HTTPPATH . "index.php/private/cpd/buku-log/";
				$this->obj_cpd->AddActivitiesHistory($history);
				// update status tahun periode
				$params = array('no', 'waiting', $id_tahun['id_tahun_periode']);
				$this->obj_cpd->ProcessingRawData("UpdateStatusTahunPeriodeById", $params);
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("LAST_INPUT" => $data, "TAHUN" => $this->arr_params['tahun_kegiatan'], 
				"BULAN" => $this->arr_params['bulan_kegiatan'], "DAY" => $this->arr_params['hari_kegiatan']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("LAST_INPUT" => $data, "TAHUN" => $this->arr_params['tahun_kegiatan'], 
			"BULAN" => $this->arr_params['bulan_kegiatan'], "DAY" => $this->arr_params['hari_kegiatan']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'peserta', array($this->arr_params['id_corse']));
	}
	
	private function Registrasi(){	
		//print_r($this->arr_params['id_person']);exit;
		// inisialize variable --------------------------------------------
		$err = array();		
		//$filled = array();
		// required -------------------------------------------
		
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Nama lengkap</strong> harus diisi'; }
		if(empty($this->arr_params['id_corse'])){ $err[] = '<br /><strong>Tempat lahir</strong> harus diisi'; }
		//if(empty($this->arr_params['ukuran'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }
		
		// id city
		/*$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));
		if(empty($kota)){ $err[] = '<br /><strong>Data kota</strong> tidak ditemukan'; }*/
		// processing -----------------------------------------------------
		if(empty($err)){
			$tgl_bayar = $this->arr_params['tahun_bayar']."-".$this->arr_params['bulan_bayar']."-".$this->arr_params['hari_bayar'];

			$berkas = $_FILES['file_attach'];
			$id = $this->obj_course->GetLastIdPeserta(array());	
			$file_name = str_replace(' ', '_', $berkas['name']);
			$file_path = "doc/karya_ilmiah/".$id."/";
			
			$params = array($this->arr_params['id_person'], 
							$this->arr_params['id_corse'],  
							$this->arr_params['baju'], 
							$this->arr_params['utusan'], 
							$file_name,
							$file_path,
							$tgl_bayar,
							$this->str_userid);
			// execute process
			//$this->obj_course->DebugQuery("InsertPeserta",$params);exit;
			if($this->obj_course->ProcessingData("InsertPeserta",$params)){
				// uploadfile	
				self::UploadBerkas($berkas,$id);
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, "jenis_kelamin" => $this->arr_params['jenis_kelamin'], "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, "jenis_kelamin" => $this->arr_params['jenis_kelamin'], "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
		// redirect page --------------------------------------------------		
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], 'anggota', 'anggota', 'view', array());
	}	
	
	
	
	private function UploadBerkas($berkas,$id){

		$err = array();

		// allowed type

		$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');

		// --

		if(!empty($berkas['tmp_name']) AND $berkas['size'] <= 1000000){

			// name and path file

			$file_name = str_replace(' ', '_', $berkas['name']);

			$file_path = "doc/karya_ilmiah/".$id."/";

			// processing

			if($this->obj_upload->FileUpload($berkas, $file_path)){

				// insert to database

				//$params = array($file_name, $file_path, $id);
				//$this->obj_course->DebugQuery("UpdateFilePath", $params);exit;
				//$this->obj_course->ProcessingData("UpdateFilePath", $params);

				// --

				$err[] = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 

			}else{

				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}		

		}else{

			$err[] = '<br />Berkas <strong>tidak berhasil</strong> diupload'; 

		}		

		// return

		return $err;

	}
	
	
	// usulan pelatihan
	private function UploadModul($str_idusulan){		
		$this->obj_upload->file_accept = array('jpg', 'jpeg', 'gif', 'png', 'pdf');
		// name and path file
		$file_name = str_replace(' ', '_', $_FILES['file_modul']['name']);
		$file_path = "doc/usulan/jadwal/".$str_idusulan.'/';
		//$params = array($file_name, $file_path, $str_idusulan);
		//$this->obj_course->DebugQuery("UpdateFileModul", $params);exit;
		
		// delete last 
		$this->obj_upload->RemoveDir($file_path);
		
		// processing
		if($this->obj_upload->FileUpload($_FILES['file_modul'], $file_path)){
			if(!empty($str_idusulan)){
				// update to database
				//echo "update " .$str_person;exit;
				$params = array($file_name, $file_path, $str_idusulan);
				//$this->obj_peserta->DebugQuery("UpdateFileModul", $params);exit;
				$this->obj_course->ProcessingData("UpdateFileSertfikat", $params);
			}else{
				// insert to database
				//echo "insert " .$str_person;exit;
				
					$params = array($file_name, $file_path,  $str_idusulan);
				//$this->obj_peserta->DebugQuery("UpdateFileModul", $params);exit;
				$this->obj_course->ProcessingData("UpdateFileSertfikat", $params);
			}
			// err message
			return true;
		}else{
			return false;
		}		
	}
	
	
	private function UploadLampiran($str_idusulan){		
		$this->obj_upload->file_accept = array('jpg', 'jpeg', 'gif', 'png', 'pdf');
		// name and path file
		$file_name = str_replace(' ', '_', $_FILES['file_lamp']['name']);
		$file_path = "doc/usulan/lampiran/".$str_idusulan.'/';
		// delete last 
		$this->obj_upload->RemoveDir($file_path);
		// processing
		if($this->obj_upload->FileUpload($_FILES['file_lamp'], $file_path)){
			if(!empty($str_idusulan)){
				// update to database
				//echo "update " .$str_person;exit;
				$params = array($file_name, $file_path, $str_idusulan);
				//$this->obj_course->DebugQuery("UpdateFileLamp", $params);exit;
				$this->obj_course->ProcessingData("UpdateFileLamp", $params);
			}else{
				// insert to database
				//echo "insert " .$str_person;exit;
					$params = array($file_name, $file_path,  $str_idusulan);
				//$this->obj_course->DebugQuery("UpdateFileLamp", $params);exit;
				$this->obj_course->ProcessingData("UpdateFileLamp", $params);
			}
			// err message
			return true;
		}else{
			return false;
		}		
	}
	
	// usulan pelatihan
	private function UploadSertifikat($str_idusulan){		
		$this->obj_upload->file_accept = array('jpg', 'jpeg', 'gif', 'png', 'pdf');
		// name and path file
		$file_name = str_replace(' ', '_', $_FILES['file_sertifikat']['name']);
		$file_path = "doc/event/sertifikat/".$str_idusulan.'/';
		// delete last 
		$this->obj_upload->RemoveDir($file_path);
		// processing
		if($this->obj_upload->FileUpload($_FILES['file_sertifikat'], $file_path)){
			if(!empty($str_idusulan)){
				// update to database
				//echo "update " .$str_person;exit;
				$params = array($file_name, $file_path, $str_idusulan);
				//$this->obj_peserta->DebugQuery("UpdateImangeNpwp", $params);exit;
				$this->obj_course->ProcessingData("UpdateFileSertfikat", $params);
			}else{
				// insert to database
				//echo "insert " .$str_person;exit;
				
					$params = array($file_name, $file_path, $str_idusulan);
				//$this->obj_peserta->DebugQuery("UpdateImangeNpwp", $params);exit;
				$this->obj_course->ProcessingData("UpdateFileSertfikat", $params);
			}
			// err message
			return true;
		}else{
			return false;
		}		
	}
	
	private function InsertDataUsulan(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// check / validate parameter 
		if(empty($this->arr_params['nama_pelatihan'])){ $err[] = '<br /><strong>Nama Pelatihan</strong> must be filled'; }
		//if(empty($this->arr_params['instansi'])){ $err[] = '<br /><strong>Institusi Pengusul</strong> must be filled'; }
		if(empty($this->arr_params['ketua'])){ $err[] = '<br /><strong>Ketua Panitia</strong> must be filled'; }
		if(empty($this->arr_params['tempat'])){ $err[] = '<br /><strong>Tempat</strong> must be filled'; }
		$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));
		//print_r($kota);exit;
		// processing --------------------------------------------------		
		if(empty($err)){
				
				$params = array($this->arr_params['nama_pelatihan'],
							$this->arr_params['penyelenggara'],
							$this->arr_params['no_sk'],
							$this->arr_params['ketua'],
							$this->arr_params['tgl_pelatihan_awal'],
							$this->arr_params['tgl_pelatihan_akhir'],
							$this->arr_params['tgl_pendaftaran_awal'],
							$this->arr_params['tgl_pendaftaran_akhir'],
							$this->arr_params['tempat'],
							$this->arr_params['lama_pelatihan'],
							$this->arr_params['jml_peserta'],
							$this->arr_params['jml_jpl'],
							$this->arr_params['skp_peserta'],
							$this->arr_params['skp_panitia'],
							$this->arr_params['skp_moderator'],
							$this->arr_params['skp_narasumber'],
							$this->arr_params['anggaran'],
							$kota,
							$this->arr_params['verifikasi'],
							$this->str_userid);
		
				//print_r($params);
							
				//$this->obj_course->DebugQuery("SaveUsulanPelatihan", $params);exit;
				if($this->obj_course->ProcessingData("SaveUsulanPelatihan", $params)){
							
				$result = $this->obj_course->GetDataAsSingleArray("GetUsulanMaxById", array());
				$this->arr_strid =$result['id'] ;
				
				
				// upload Modul
		if(isset($_FILES['file_modul']['tmp_name']) AND !empty($_FILES['file_modul']['tmp_name'])){
			if(!self::UploadModul(($result['id']))){
				$err[] = '<br />Sertifikat<strong>tidak berhasil</strong> diupload';
			}
		}
		// upload lampiran
		if(isset($_FILES['file_lamp']['tmp_name']) AND !empty($_FILES['file_lamp']['tmp_name'])){
			if(!self::UploadLampiran(($result['id']))){
				$err[] = '<br />Lampiran<strong>tidak berhasil</strong> diupload';
			}
		}
				
				self::SendNotification($err, $filled, 'Data berhasil disimpan.', 'success');
			}else{
				// error message
				$filled = array("NAMA_PELATIHAN" => $this->arr_params['nama_pelatihan'], 
									"KETUA" => $this->arr_params['ketua'], 
									$this->arr_params['gender'] => 'selected="selected"', 
									"TGL_PELATIHAN_AWAL" => $this->arr_params['tgl_pelatihan_awal'], 
									"TGL_PELATIHAN_AKHIR" => $this->arr_params['tgl_pelatihan_akhir'], 
									"TEMPAT" => $this->arr_params['TEMPAT'], 
									"LAMA_PELATIHAN" => $this->arr_params['lama_pelatihan'], 
									"JML_PESERTA" => $this->arr_params['jml_peserta'], 
									"JML_JPL" => $this->arr_params['jml_jpl'], 
									"ANGGARAN" => $this->arr_params['anggaran']
									);
					$filled = array_merge($params,$filled);		
				self::SendNotification($err, $filled, 'Data gagal disimpan.', 'error');
			}
		}else{
			// error message
			self::SendNotification($err, $filled, 'Lihat kembali data yang perlu diisi.', 'error');
			
		/** Redirect result to default page */
		
	}	
	$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'course','add');
}

	private function RegisterkehadiranPeserta(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Id</b> tidak terpilih'; }
		// processing --------------------------------------------------
		if(empty($err)){			
			foreach($this->arr_params['downcheck'] as $id){
				// delete calon anggota
				//$this->obj_course->DebugQuery("UpdateStatusPeserta",array($id));exit;
				$this->obj_course->UpdateStatusPeserta(array("yes",$id));
					self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			}
		}
		// redirect to page ------------------------------------	
		//$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'course','peserta',array($this->arr_params['id_periode']));
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'peserta', array($this->arr_params['id_periode']));
	}
	
    private function RegisterkehadiranPesertaBatal(){
		// inisialize variable --------------------------------------------
		$err = array();		
		$filled = array();
		// ----------------------------------------------------------------	
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><b>Id</b> tidak terpilih'; }
		// processing --------------------------------------------------
		if(empty($err)){			
			foreach($this->arr_params['downcheck'] as $id){
				// delete calon anggota
				//$this->obj_course->DebugQuery("UpdateStatusPeserta",array("no",$id));exit;
				$this->obj_course->UpdateStatusPeserta(array("no",$id));
					self::SendNotification($err, $filled, 'Data has been saved.', 'success');
			}
		}
		// redirect to page ------------------------------------	
		//$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'course','peserta',array($this->arr_params['id_periode']));
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'peserta', array($this->arr_params['id_periode']));
	}	
}

?>