<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	protected $obj_data;
	protected $obj_notify;
	private $obj_paging;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// business object loaded
		$this->obj_data = $this->obj_ctrl->LoadBusiness('files', 'mysql', $this->arr_config['db']);
		$this->obj_paging = $this->obj_ctrl->LoadExternalClass('PaginationSelectedMySQL');
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		// display test cookies
		self::DisplayNotification();
		// display data
		self::DisplayPageLink();
		self::DisplayRedirect();
			
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	//Function DisplayPageLink
	private function DisplayPageLink(){
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array( $this->arr_routes['params'][0], $this->arr_routes['params'][1],'add')));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'],array( $this->arr_routes['params'][0],$this->arr_routes['params'][1])));
      $this->obj_tmpl->addVar('content', 'URL_CATEGORY', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'view-category'));
		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// parse kategori
		//$this->obj_tmpl->addVar('display', 'KATEGORI', $this->arr_routes['params']['0']);
	}
	//Function Redirect
	private function DisplayRedirect() {
      if (isset($this->arr_routes['params']['2']) && $this->arr_routes['params']['2'] == "add") {
         self::DisplayAddForm();
      } else if (isset($this->arr_routes['params']['2']) && $this->arr_routes['params']['2'] == "edit") {
         self::DisplayEditForm();
      } else {
         self::DisplayListFiles();
      }
   }
	
	private function DisplayListFiles(){
		$this->obj_tmpl->addVar('content', 'VIEW_ACTIVE', 'class="tab-nav-active"');
		if(!isset($this->arr_routes['params']['1'])) {
			$page = 1;
		} else {
			$page = $this->arr_routes['params']['1'];
		}
		
		if(!isset($this->arr_routes['params']['0'])) {
			$cat = 1;
		} else {
			$cat = $this->arr_routes['params']['0'];
		}
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(10);
		// set total record
		$this->obj_paging->SetTotalRecord($this->obj_data->CountDataCourse(array($cat)));
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'],array($cat,'/')));
		// set template
		$this->obj_paging->SetTempatePaging('pagination');
		// parse paging
		$this->obj_paging->ParsePaging();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		//$news = $this->obj_news->GetDataAsArray('GetLatestNews',array($start, $max));
		$rs_id = $this->obj_data->GetDataAsArray("GetListFileCourse", array($cat,$start, $max));
		//print_r ($rs_id);
		$no = 0;
		$num = $start+1;
			// --
			$this->obj_tmpl->addVar('display', 'ID_CAT', $cat);
			$this->obj_tmpl->addVar('display', 'PAGE', $page);	
			foreach($rs_id as $key=>$rec) {
			//while($rec = mysqli_fetch_assoc($rs_id)){
				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download', array(md5($rec['id_file'])));
				$url_edit =  $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array( $this->arr_routes['params'][0], $this->arr_routes['params'][1],'edit',$rec['id_file']));
				// --
				$this->obj_tmpl->addVar('list_data', 'URL_EDIT',$url_edit);
				if($rec['active']==1) {
					$ico = HTTPPATH.'/doc/temp/greedin-ico.jpg';
					$img = '<div align="center"><a href="'.$url_edit.'"><img src="'.$ico.'" border=\"0\"/></div>';
					// $status='True';
				}else {
			 		$ico = HTTPPATH.'/doc/temp/redin-ico.jpg';
					$img = '<div align="center"><a href="'.$url_edit.'"><img src="'.$ico.'" border=\"0\"/></div>';
				}
				
				$this->obj_tmpl->addVar('list_data', 'NO', $num);
				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_file']);
				$this->obj_tmpl->addVar('list_data', 'JUDUL', $rec['file_name']);
				$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $rec['description']);
				$this->obj_tmpl->addVar('list_data', 'STATUS', $img);
				$this->obj_tmpl->addVar('list_data', 'URL_DOWNLOAD', $url);
				$this->obj_tmpl->ParseTemplate('list_data', 'a');			
				$no++;
				$num++;
				
			}
				
	}
	
	private function DisplayAddForm(){
		// activated template
		$this->obj_tmpl->addVar('content', 'ADD_ACTIVE', 'class="tab-nav-active"');
		$this->obj_tmpl->addVar('display', 'view', 'add');
		if(isset($this->obj_notify->arr_message['field'])){
			$result = array($this->obj_notify->arr_message['field']);
			//print_r($result);
			
			$this->obj_tmpl->addVar('display', 'ID_CAT', $result[0]['id_cat']);
			$this->obj_tmpl->addVar('display', 'PAGE', $result[0]['page']);
			$this->obj_tmpl->addVar('display', 'MOD', $result[0]['mod']);
			$this->obj_tmpl->addVar('display', 'JUDUL', $result[0]['judul']);
			$this->obj_tmpl->addVar('display', 'DESKRIPSI', $result[0]['deskripsi']);
			
		}else{
			$this->obj_tmpl->addVar('display', 'ID_CAT', $this->arr_routes['params'][0]);
			$this->obj_tmpl->addVar('display', 'PAGE', $this->arr_routes['params'][1]);
			$this->obj_tmpl->addVar('display', 'MOD', 'add');
		
		}
		
		
		$rs_id = $this->obj_data->GetResourceId("GetListKategori", array(0, 100));
		if($rs_id){
			while($rec = mysqli_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('cat_add', 'CAT_VALUE', $rec['id_cat']);
				$this->obj_tmpl->addVar('cat_add', 'CAT_NAME', $rec['judul']);
				if ($rec['id_cat'] == $this->arr_routes['params'][0]) {
					$this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', 'selected="selected"');
				} else {
					$this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');
				}
				$this->obj_tmpl->ParseTemplate('cat_add', 'a');
			}
		}
      
      /*$cat = $this->obj_news->GetCategory(array(0, 1000));
      foreach($cat as $key=>$value ) {
         $this->obj_tmpl->addVar('cat_add', 'CAT_VALUE', $value['id_cat']);
         $this->obj_tmpl->addVar('cat_add', 'CAT_NAME', $value['nama']);
         if (isset($result['0']['id_cat'])) {
            if ($value['id_cat'] == $result['0']['id_cat']) {
               $this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', 'selected');
            } else {
               $this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');
            }
         } else {
            $this->obj_tmpl->addVar('cat_add', 'CAT_SELECTED', '');
         }
         $this->obj_tmpl->ParseTemplate('cat_add', 'a');
      }*/
	}
	
	private function DisplayEditForm(){
		// activated template
		$this->obj_tmpl->addVar('content', 'EDIT_ACTIVE', '<li><a href="#" class="tab-nav-active">Edit</a></li>');
		$this->obj_tmpl->addVar('display', 'view', 'edit');
		// parse data	
		$result = $this->obj_data->GetDataAsSingleArray('GetDetailedFileCourseById',array($this->arr_routes['params']['3']));
		if(!empty($result)){
			$this->obj_tmpl->addVar('display', 'ID', $result['id_file']);
			$this->obj_tmpl->addVar('display', 'JUDUL', $result['title']);
			$this->obj_tmpl->addVar('display', 'DESKRIPSI', $result['description']);
			$this->obj_tmpl->addVar('display', 'ID_CAT', $this->arr_routes['params'][0]);
			$this->obj_tmpl->addVar('display', 'PAGE', $this->arr_routes['params'][1]);
			$this->obj_tmpl->addVar('display', 'MOD', 'edit');
			$file = $result['path'].'/'. $result['file_name'];
			//echo $file;
				if (is_file ($file)){
					$this->obj_tmpl->addVar('display', 'LASTFILE', $result['file_name']);
				}else{	
					$this->obj_tmpl->addVar('display', 'LASTFILE', 'Missing File');
				}
				
				if ($result['active'] == 0){
					$this->obj_tmpl->addVar('display', 'USES', 'checked="checked"');
				}
				
		// get data kategori
		$rs_id = $this->obj_data->GetResourceId("GetListKategori", array(0, 100));
		if($rs_id){
			while($rec = mysqli_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('cat_edit', 'CAT_VALUE', $rec['id_cat']);
				$this->obj_tmpl->addVar('cat_edit', 'CAT_NAME', $rec['judul']);
				if($rec['id_cat'] == $this->arr_routes['params'][0]) {
					$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', 'selected="selected"');
				}else{
					$this->obj_tmpl->addVar('cat_edit', 'CAT_SELECTED', '');
				}
				$this->obj_tmpl->ParseTemplate('cat_edit', 'a');
			}
		}
		}      
      	
	}
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'content');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
}

?>